package com.dbxml.db.client.tools.command;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: WildcardMatcher.java,v 1.3 2004/02/12 00:17:55 bradford Exp $
 */

import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * WildcardMatcher is a utility class that does wildcard matching against
 * individual names.
 */

final class WildcardMatcher {
   private Matcher matcher;

   public WildcardMatcher(String wildcard) {
      StringBuffer sb = new StringBuffer(wildcard.length());
      StringTokenizer st = new StringTokenizer(wildcard, "?*.", true);
      while ( st.hasMoreTokens() ) {
         String t = st.nextToken();
         if ( t.equals(".") )
            sb.append("\\.");
         else if ( t.equals("?") )
            sb.append(".");
         else if ( t.equals("*") )
            sb.append(".*");
         else
            sb.append(t);
      }

      Pattern pattern = Pattern.compile(sb.toString(), Pattern.CASE_INSENSITIVE);
      matcher = pattern.matcher("");
   }

   public boolean matches(String name) {
      matcher.reset(name);
      return matcher.matches();
   }
}
